/* AboutWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from AboutWindow.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	HE_ABOUT_WINDOW_0_PROPERTY,
	HE_ABOUT_WINDOW_COLOR_PROPERTY,
	HE_ABOUT_WINDOW_LICENSE_PROPERTY,
	HE_ABOUT_WINDOW_VERSION_PROPERTY,
	HE_ABOUT_WINDOW_APP_NAME_PROPERTY,
	HE_ABOUT_WINDOW_ICON_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY,
	HE_ABOUT_WINDOW_APP_ID_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY,
	HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY,
	HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY,
	HE_ABOUT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_about_window_properties[HE_ABOUT_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;

struct _HeAboutWindowPrivate {
	GtkOverlay* window_overlay;
	GtkBox* about_box;
	GtkBox* content_box;
	GtkBox* button_box;
	GtkBox* info_box;
	GtkBox* title_box;
	GtkBox* text_box;
	GtkLabel* title_label;
	GtkLabel* copyright_label;
	GtkLabel* translators_label;
	GtkLabel* license_label;
	GtkImage* icon_image;
	HeButton* translate_app_button;
	HeButton* report_button;
	HeButton* more_info_button;
	HeModifierBadge* version_badge;
	HeColors _color;
	HeAboutWindowLicenses _license;
	gchar** translators;
	gint translators_length1;
	gint _translators_size_;
	gchar** developers;
	gint developers_length1;
	gint _developers_size_;
	gint _copyright_year;
	gchar* _translate_url;
	gchar* _issue_url;
	gchar* _more_info_url;
	gchar* _app_id;
};

struct _Block3Data {
	int _ref_count_;
	HeAboutWindow* self;
	GtkUriLauncher* uri_launcher;
};

static gint HeAboutWindow_private_offset;
static gpointer he_about_window_parent_class = NULL;

static gchar** _vala_array_dup13 (gchar** self,
                           gssize length);
static void he_about_window_update_copyright (HeAboutWindow* self,
                                       gint year,
                                       gchar** developers,
                                       gint developers_length1);
static gchar** _vala_array_dup14 (gchar** self,
                           gssize length);
static GObject * he_about_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _he_about_window___lambda124_ (Block3Data* _data3_);
static void __he_about_window___lambda124__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda125_ (Block3Data* _data3_);
static void __he_about_window___lambda125__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _he_about_window___lambda126_ (Block3Data* _data3_);
static void __he_about_window___lambda126__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _gtk_window_close_gtk_button_clicked (GtkButton* _sender,
                                           gpointer self);
static void he_about_window_finalize (GObject * obj);
static GType he_about_window_get_type_once (void);
static void _vala_he_about_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_about_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_about_window_get_instance_private (HeAboutWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeAboutWindow_private_offset);
}

/**
     * An enum of commonly used licenses to be used in AboutWindow.
     */
/**
         * Returns the license url for the license.
         */
gchar*
he_about_window_licenses_get_url (HeAboutWindowLicenses self)
{
	gchar* result;
#line 62 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 168 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 64 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("https://choosealicense.com/licenses/gpl-3.0");
#line 64 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 64 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 177 "AboutWindow.c"
		}
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 181 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 66 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("https://choosealicense.com/licenses/mit");
#line 66 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 66 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 190 "AboutWindow.c"
		}
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 194 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 68 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("https://choosealicense.com/licenses/mpl-2.0");
#line 68 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 68 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 203 "AboutWindow.c"
		}
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 207 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 70 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("https://choosealicense.com/licenses/unlicense");
#line 70 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 70 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 216 "AboutWindow.c"
		}
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 220 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 72 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("https://choosealicense.com/licenses/apache-2.0");
#line 72 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 72 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 229 "AboutWindow.c"
		}
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 233 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 74 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("https://choosealicense.com/licenses/wtfpl");
#line 74 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 74 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 242 "AboutWindow.c"
		}
#line 62 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 246 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 76 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("https://choosealicense.com/no-permission");
#line 76 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 76 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 255 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 78 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("about:blank");
#line 78 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 78 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 266 "AboutWindow.c"
		}
	}
}

/**
         * Returns the license name for the license.
         */
gchar*
he_about_window_licenses_get_name (HeAboutWindowLicenses self)
{
	gchar* result;
#line 86 "../lib/Widgets/AboutWindow.vala"
	switch (self) {
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
#line 282 "AboutWindow.c"
		{
			gchar* _tmp0_;
#line 88 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup ("GPLv3");
#line 88 "../lib/Widgets/AboutWindow.vala"
			result = _tmp0_;
#line 88 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 291 "AboutWindow.c"
		}
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MIT:
#line 295 "AboutWindow.c"
		{
			gchar* _tmp1_;
#line 90 "../lib/Widgets/AboutWindow.vala"
			_tmp1_ = g_strdup ("MIT");
#line 90 "../lib/Widgets/AboutWindow.vala"
			result = _tmp1_;
#line 90 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 304 "AboutWindow.c"
		}
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
#line 308 "AboutWindow.c"
		{
			gchar* _tmp2_;
#line 92 "../lib/Widgets/AboutWindow.vala"
			_tmp2_ = g_strdup ("MPLv2");
#line 92 "../lib/Widgets/AboutWindow.vala"
			result = _tmp2_;
#line 92 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 317 "AboutWindow.c"
		}
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
#line 321 "AboutWindow.c"
		{
			gchar* _tmp3_;
#line 94 "../lib/Widgets/AboutWindow.vala"
			_tmp3_ = g_strdup ("Unlicense");
#line 94 "../lib/Widgets/AboutWindow.vala"
			result = _tmp3_;
#line 94 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 330 "AboutWindow.c"
		}
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
#line 334 "AboutWindow.c"
		{
			gchar* _tmp4_;
#line 96 "../lib/Widgets/AboutWindow.vala"
			_tmp4_ = g_strdup ("Apache License v2");
#line 96 "../lib/Widgets/AboutWindow.vala"
			result = _tmp4_;
#line 96 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 343 "AboutWindow.c"
		}
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
#line 347 "AboutWindow.c"
		{
			gchar* _tmp5_;
#line 98 "../lib/Widgets/AboutWindow.vala"
			_tmp5_ = g_strdup ("WTFPL");
#line 98 "../lib/Widgets/AboutWindow.vala"
			result = _tmp5_;
#line 98 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 356 "AboutWindow.c"
		}
#line 86 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
#line 360 "AboutWindow.c"
		{
			gchar* _tmp6_;
#line 100 "../lib/Widgets/AboutWindow.vala"
			_tmp6_ = g_strdup ("a proprietary license");
#line 100 "../lib/Widgets/AboutWindow.vala"
			result = _tmp6_;
#line 100 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 369 "AboutWindow.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 102 "../lib/Widgets/AboutWindow.vala"
			_tmp7_ = g_strdup ("N/A");
#line 102 "../lib/Widgets/AboutWindow.vala"
			result = _tmp7_;
#line 102 "../lib/Widgets/AboutWindow.vala"
			return result;
#line 380 "AboutWindow.c"
		}
	}
}

static GType
he_about_window_licenses_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_ABOUT_WINDOW_LICENSES_GPLV3, "HE_ABOUT_WINDOW_LICENSES_GPLV3", "gplv3"}, {HE_ABOUT_WINDOW_LICENSES_MIT, "HE_ABOUT_WINDOW_LICENSES_MIT", "mit"}, {HE_ABOUT_WINDOW_LICENSES_MPLV2, "HE_ABOUT_WINDOW_LICENSES_MPLV2", "mplv2"}, {HE_ABOUT_WINDOW_LICENSES_UNLICENSE, "HE_ABOUT_WINDOW_LICENSES_UNLICENSE", "unlicense"}, {HE_ABOUT_WINDOW_LICENSES_APACHEV2, "HE_ABOUT_WINDOW_LICENSES_APACHEV2", "apachev2"}, {HE_ABOUT_WINDOW_LICENSES_WTFPL, "HE_ABOUT_WINDOW_LICENSES_WTFPL", "wtfpl"}, {HE_ABOUT_WINDOW_LICENSES_PROPRIETARY, "HE_ABOUT_WINDOW_LICENSES_PROPRIETARY", "proprietary"}, {0, NULL, NULL}};
	GType he_about_window_licenses_type_id;
	he_about_window_licenses_type_id = g_enum_register_static ("HeAboutWindowLicenses", values);
	return he_about_window_licenses_type_id;
}

GType
he_about_window_licenses_get_type (void)
{
	static volatile gsize he_about_window_licenses_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_licenses_type_id__once)) {
		GType he_about_window_licenses_type_id;
		he_about_window_licenses_type_id = he_about_window_licenses_get_type_once ();
		g_once_init_leave (&he_about_window_licenses_type_id__once, he_about_window_licenses_type_id);
	}
	return he_about_window_licenses_type_id__once;
}

HeColors
he_about_window_get_color (HeAboutWindow* self)
{
	HeColors result;
#line 113 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 114 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_color;
#line 114 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 416 "AboutWindow.c"
}

void
he_about_window_set_color (HeAboutWindow* self,
                           HeColors value)
{
	HeButton* _tmp0_;
	HeButton* _tmp1_;
	HeButton* _tmp2_;
	HeModifierBadge* _tmp3_;
#line 116 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 117 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = value;
#line 118 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translate_app_button;
#line 118 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color (_tmp0_, value);
#line 119 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->report_button;
#line 119 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color (_tmp1_, value);
#line 120 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = self->priv->more_info_button;
#line 120 "../lib/Widgets/AboutWindow.vala"
	he_button_set_color (_tmp2_, value);
#line 121 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = self->priv->version_badge;
#line 121 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_color (_tmp3_, value);
#line 116 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY]);
#line 449 "AboutWindow.c"
}

HeAboutWindowLicenses
he_about_window_get_license (HeAboutWindow* self)
{
	HeAboutWindowLicenses result;
#line 131 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 131 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_license;
#line 131 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 462 "AboutWindow.c"
}

void
he_about_window_set_license (HeAboutWindow* self,
                             HeAboutWindowLicenses value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 132 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 133 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = value;
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->license_label;
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("This program is licensed under %s"), "<a href=\"%s\">%s</a>");
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = he_about_window_licenses_get_url (value);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = _tmp3_;
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = he_about_window_licenses_get_name (value);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = _tmp5_;
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = g_strdup_printf (_tmp2_, _tmp4_, _tmp6_);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = _tmp7_;
#line 134 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_markup (_tmp0_, _tmp8_);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp8_);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp6_);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp4_);
#line 134 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp2_);
#line 132 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY]);
#line 512 "AboutWindow.c"
}

const gchar*
he_about_window_get_version (HeAboutWindow* self)
{
	const gchar* result;
	HeModifierBadge* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 142 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 142 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_modifier_badge_get_label (_tmp0_);
#line 142 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 142 "../lib/Widgets/AboutWindow.vala"
	result = _tmp2_;
#line 142 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 534 "AboutWindow.c"
}

void
he_about_window_set_version (HeAboutWindow* self,
                             const gchar* value)
{
	HeModifierBadge* _tmp0_;
#line 143 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 143 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->version_badge;
#line 143 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_label (_tmp0_, value);
#line 143 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY]);
#line 550 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_name (HeAboutWindow* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
#line 150 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 150 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_label_get_text (_tmp0_);
#line 150 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 150 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 569 "AboutWindow.c"
}

void
he_about_window_set_app_name (HeAboutWindow* self,
                              const gchar* value)
{
	GtkLabel* _tmp0_;
#line 151 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 151 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->title_label;
#line 151 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_text (_tmp0_, value);
#line 151 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY]);
#line 585 "AboutWindow.c"
}

const gchar*
he_about_window_get_icon (HeAboutWindow* self)
{
	const gchar* result;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
#line 158 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 158 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
#line 158 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 158 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 604 "AboutWindow.c"
}

void
he_about_window_set_icon (HeAboutWindow* self,
                          const gchar* value)
{
	GtkImage* _tmp0_;
#line 159 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 159 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->icon_image;
#line 159 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_from_icon_name (_tmp0_, value);
#line 159 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY]);
#line 620 "AboutWindow.c"
}

gchar**
he_about_window_get_translator_names (HeAboutWindow* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 167 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->translators;
#line 167 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->translators_length1;
#line 167 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 167 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 167 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 167 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 646 "AboutWindow.c"
	}
#line 167 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 167 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 652 "AboutWindow.c"
}

static gchar**
_vala_array_dup13 (gchar** self,
                   gssize length)
{
#line 169 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 661 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 169 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 169 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 668 "AboutWindow.c"
			gchar* _tmp0_;
#line 169 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 169 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 674 "AboutWindow.c"
		}
#line 169 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 678 "AboutWindow.c"
	}
#line 169 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 682 "AboutWindow.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 696 "AboutWindow.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 700 "AboutWindow.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 706 "AboutWindow.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 711 "AboutWindow.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 717 "AboutWindow.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 721 "AboutWindow.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 725 "AboutWindow.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 729 "AboutWindow.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 733 "AboutWindow.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 737 "AboutWindow.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 752 "AboutWindow.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 761 "AboutWindow.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 768 "AboutWindow.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 774 "AboutWindow.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 782 "AboutWindow.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 786 "AboutWindow.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 792 "AboutWindow.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 797 "AboutWindow.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 803 "AboutWindow.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 807 "AboutWindow.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 811 "AboutWindow.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 817 "AboutWindow.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 823 "AboutWindow.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 835 "AboutWindow.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 839 "AboutWindow.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 843 "AboutWindow.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 848 "AboutWindow.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 856 "AboutWindow.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 874 "AboutWindow.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 880 "AboutWindow.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 884 "AboutWindow.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 892 "AboutWindow.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 901 "AboutWindow.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 910 "AboutWindow.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 916 "AboutWindow.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 924 "AboutWindow.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 936 "AboutWindow.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 942 "AboutWindow.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 946 "AboutWindow.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 954 "AboutWindow.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 965 "AboutWindow.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 974 "AboutWindow.c"
	}
}

void
he_about_window_set_translator_names (HeAboutWindow* self,
                                      gchar** value,
                                      gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 168 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 169 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup13 (value, value_length1) : value;
#line 169 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 169 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 169 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp0_;
#line 169 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = _tmp0__length1;
#line 169 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 170 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = self->priv->translators;
#line 170 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = self->priv->translators_length1;
#line 170 "../lib/Widgets/AboutWindow.vala"
	if (_tmp1__length1 > 0) {
#line 1007 "AboutWindow.c"
		GtkLabel* _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->translators_label;
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp3_ = self->priv->translators;
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp3__length1 = self->priv->translators_length1;
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = _vala_g_strjoinv (", ", _tmp3_, (gint) _tmp3__length1);
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = _tmp4_;
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = g_strdup_printf (_ ("Translated By: %s"), _tmp5_);
#line 171 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = _tmp6_;
#line 171 "../lib/Widgets/AboutWindow.vala"
		gtk_label_set_text (_tmp2_, _tmp7_);
#line 171 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp7_);
#line 171 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp5_);
#line 172 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = self->priv->translators_label;
#line 172 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 1040 "AboutWindow.c"
	} else {
		GtkLabel* _tmp9_;
		GtkLabel* _tmp10_;
#line 174 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = self->priv->translators_label;
#line 174 "../lib/Widgets/AboutWindow.vala"
		gtk_label_set_text (_tmp9_, "");
#line 175 "../lib/Widgets/AboutWindow.vala"
		_tmp10_ = self->priv->translators_label;
#line 175 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 1052 "AboutWindow.c"
	}
#line 168 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY]);
#line 1056 "AboutWindow.c"
}

static void
he_about_window_update_copyright (HeAboutWindow* self,
                                  gint year,
                                  gchar** developers,
                                  gint developers_length1)
{
	gchar* _tmp0_ = NULL;
	gchar* developers_text = NULL;
	gchar* _tmp3_;
#line 180 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 181 "../lib/Widgets/AboutWindow.vala"
	if (developers_length1 > 0) {
#line 1072 "AboutWindow.c"
		gchar* _tmp1_;
#line 181 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = _vala_g_strjoinv (", ", developers, (gint) developers_length1);
#line 181 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp0_);
#line 181 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = _tmp1_;
#line 1080 "AboutWindow.c"
	} else {
		gchar* _tmp2_;
#line 181 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = g_strdup ("");
#line 181 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp0_);
#line 181 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = _tmp2_;
#line 1089 "AboutWindow.c"
	}
#line 181 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 181 "../lib/Widgets/AboutWindow.vala"
	developers_text = _tmp3_;
#line 183 "../lib/Widgets/AboutWindow.vala"
	if (year > 0) {
#line 1097 "AboutWindow.c"
		GtkLabel* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 184 "../lib/Widgets/AboutWindow.vala"
		_tmp4_ = self->priv->copyright_label;
#line 184 "../lib/Widgets/AboutWindow.vala"
		_tmp5_ = developers_text;
#line 184 "../lib/Widgets/AboutWindow.vala"
		_tmp6_ = g_strdup_printf (_ ("Copyright © %i %s"), year, _tmp5_);
#line 184 "../lib/Widgets/AboutWindow.vala"
		_tmp7_ = _tmp6_;
#line 184 "../lib/Widgets/AboutWindow.vala"
		gtk_label_set_text (_tmp4_, _tmp7_);
#line 184 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (_tmp7_);
#line 185 "../lib/Widgets/AboutWindow.vala"
		_tmp8_ = self->priv->copyright_label;
#line 185 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 1119 "AboutWindow.c"
	} else {
		const gchar* _tmp9_;
#line 186 "../lib/Widgets/AboutWindow.vala"
		_tmp9_ = developers_text;
#line 186 "../lib/Widgets/AboutWindow.vala"
		if (g_strcmp0 (_tmp9_, "") != 0) {
#line 1126 "AboutWindow.c"
			GtkLabel* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			GtkLabel* _tmp14_;
#line 187 "../lib/Widgets/AboutWindow.vala"
			_tmp10_ = self->priv->copyright_label;
#line 187 "../lib/Widgets/AboutWindow.vala"
			_tmp11_ = developers_text;
#line 187 "../lib/Widgets/AboutWindow.vala"
			_tmp12_ = g_strdup_printf (_ ("Copyright © %s"), _tmp11_);
#line 187 "../lib/Widgets/AboutWindow.vala"
			_tmp13_ = _tmp12_;
#line 187 "../lib/Widgets/AboutWindow.vala"
			gtk_label_set_text (_tmp10_, _tmp13_);
#line 187 "../lib/Widgets/AboutWindow.vala"
			_g_free0 (_tmp13_);
#line 188 "../lib/Widgets/AboutWindow.vala"
			_tmp14_ = self->priv->copyright_label;
#line 188 "../lib/Widgets/AboutWindow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp14_, TRUE);
#line 1148 "AboutWindow.c"
		} else {
			GtkLabel* _tmp15_;
			GtkLabel* _tmp16_;
#line 190 "../lib/Widgets/AboutWindow.vala"
			_tmp15_ = self->priv->copyright_label;
#line 190 "../lib/Widgets/AboutWindow.vala"
			gtk_label_set_text (_tmp15_, "");
#line 191 "../lib/Widgets/AboutWindow.vala"
			_tmp16_ = self->priv->copyright_label;
#line 191 "../lib/Widgets/AboutWindow.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp16_, FALSE);
#line 1160 "AboutWindow.c"
		}
	}
#line 180 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (developers_text);
#line 180 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (_tmp0_);
#line 1167 "AboutWindow.c"
}

gchar**
he_about_window_get_developer_names (HeAboutWindow* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 200 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 200 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 200 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = _tmp0_;
#line 200 "../lib/Widgets/AboutWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 200 "../lib/Widgets/AboutWindow.vala"
	if (result_length1) {
#line 200 "../lib/Widgets/AboutWindow.vala"
		*result_length1 = _tmp1__length1;
#line 1193 "AboutWindow.c"
	}
#line 200 "../lib/Widgets/AboutWindow.vala"
	result = _tmp1_;
#line 200 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1199 "AboutWindow.c"
}

static gchar**
_vala_array_dup14 (gchar** self,
                   gssize length)
{
#line 202 "../lib/Widgets/AboutWindow.vala"
	if (length >= 0) {
#line 1208 "AboutWindow.c"
		gchar** result;
		gssize i;
#line 202 "../lib/Widgets/AboutWindow.vala"
		result = g_new0 (gchar*, length + 1);
#line 202 "../lib/Widgets/AboutWindow.vala"
		for (i = 0; i < length; i++) {
#line 1215 "AboutWindow.c"
			gchar* _tmp0_;
#line 202 "../lib/Widgets/AboutWindow.vala"
			_tmp0_ = g_strdup (self[i]);
#line 202 "../lib/Widgets/AboutWindow.vala"
			result[i] = _tmp0_;
#line 1221 "AboutWindow.c"
		}
#line 202 "../lib/Widgets/AboutWindow.vala"
		return result;
#line 1225 "AboutWindow.c"
	}
#line 202 "../lib/Widgets/AboutWindow.vala"
	return NULL;
#line 1229 "AboutWindow.c"
}

void
he_about_window_set_developer_names (HeAboutWindow* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	gint _tmp2_;
#line 201 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 202 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup14 (value, value_length1) : value;
#line 202 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = value_length1;
#line 202 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 202 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp0_;
#line 202 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = _tmp0__length1;
#line 202 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 203 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_copyright_year (self);
#line 203 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 203 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, _tmp2_, value, (gint) value_length1);
#line 201 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY]);
#line 1263 "AboutWindow.c"
}

gint
he_about_window_get_copyright_year (HeAboutWindow* self)
{
	gint result;
#line 212 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 212 "../lib/Widgets/AboutWindow.vala"
	result = self->priv->_copyright_year;
#line 212 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1276 "AboutWindow.c"
}

void
he_about_window_set_copyright_year (HeAboutWindow* self,
                                    gint value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 213 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 214 "../lib/Widgets/AboutWindow.vala"
	self->priv->_copyright_year = value;
#line 215 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->developers;
#line 215 "../lib/Widgets/AboutWindow.vala"
	_tmp0__length1 = self->priv->developers_length1;
#line 215 "../lib/Widgets/AboutWindow.vala"
	he_about_window_update_copyright (self, value, _tmp0_, (gint) _tmp0__length1);
#line 213 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY]);
#line 1297 "AboutWindow.c"
}

const gchar*
he_about_window_get_app_id (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 226 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 226 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_app_id;
#line 226 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 226 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1313 "AboutWindow.c"
}

void
he_about_window_set_app_id (HeAboutWindow* self,
                            const gchar* value)
{
	gchar* old_value;
#line 226 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 226 "../lib/Widgets/AboutWindow.vala"
	old_value = he_about_window_get_app_id (self);
#line 226 "../lib/Widgets/AboutWindow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1327 "AboutWindow.c"
		gchar* _tmp0_;
#line 226 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = g_strdup (value);
#line 226 "../lib/Widgets/AboutWindow.vala"
		_g_free0 (self->priv->_app_id);
#line 226 "../lib/Widgets/AboutWindow.vala"
		self->priv->_app_id = _tmp0_;
#line 226 "../lib/Widgets/AboutWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY]);
#line 1337 "AboutWindow.c"
	}
}

const gchar*
he_about_window_get_translate_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 231 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 231 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_translate_url;
#line 231 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 231 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1354 "AboutWindow.c"
}

void
he_about_window_set_translate_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 232 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 233 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 233 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 233 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translate_url = _tmp0_;
#line 234 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1372 "AboutWindow.c"
		HeButton* _tmp1_;
#line 235 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->translate_app_button;
#line 235 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1378 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 237 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->translate_app_button;
#line 237 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1385 "AboutWindow.c"
	}
#line 232 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY]);
#line 1389 "AboutWindow.c"
}

const gchar*
he_about_window_get_issue_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 245 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 245 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_issue_url;
#line 245 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 245 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1405 "AboutWindow.c"
}

void
he_about_window_set_issue_url (HeAboutWindow* self,
                               const gchar* value)
{
	gchar* _tmp0_;
#line 246 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 247 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 247 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 247 "../lib/Widgets/AboutWindow.vala"
	self->priv->_issue_url = _tmp0_;
#line 248 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1423 "AboutWindow.c"
		HeButton* _tmp1_;
#line 249 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->report_button;
#line 249 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1429 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 251 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->report_button;
#line 251 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1436 "AboutWindow.c"
	}
#line 246 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY]);
#line 1440 "AboutWindow.c"
}

const gchar*
he_about_window_get_more_info_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 259 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 259 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = self->priv->_more_info_url;
#line 259 "../lib/Widgets/AboutWindow.vala"
	result = _tmp0_;
#line 259 "../lib/Widgets/AboutWindow.vala"
	return result;
#line 1456 "AboutWindow.c"
}

void
he_about_window_set_more_info_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
#line 260 "../lib/Widgets/AboutWindow.vala"
	g_return_if_fail (self != NULL);
#line 261 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = g_strdup (value);
#line 261 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 261 "../lib/Widgets/AboutWindow.vala"
	self->priv->_more_info_url = _tmp0_;
#line 262 "../lib/Widgets/AboutWindow.vala"
	if (value != NULL) {
#line 1474 "AboutWindow.c"
		HeButton* _tmp1_;
#line 263 "../lib/Widgets/AboutWindow.vala"
		_tmp1_ = self->priv->more_info_button;
#line 263 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
#line 1480 "AboutWindow.c"
	} else {
		HeButton* _tmp2_;
#line 265 "../lib/Widgets/AboutWindow.vala"
		_tmp2_ = self->priv->more_info_button;
#line 265 "../lib/Widgets/AboutWindow.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 1487 "AboutWindow.c"
	}
#line 260 "../lib/Widgets/AboutWindow.vala"
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY]);
#line 1491 "AboutWindow.c"
}

/**
     * Creates a new AboutWindow.
     * @param parent The parent window.
     * @param app_name Your application's name.
     * @param app_id Your application's reverse-domain name.
     * @param version Your application's version.
     * @param icon Your application's icon.
     * @param translate_url A URL where contributors can help translate the application.
     * @param issue_url A URL where users can report a problem with the application.
     * @param more_info_url A URL where users can get more information about the application.
     * @param translators Your application's translators.
     * @param developers Your application's developers.
     * @param copyright_year Your application's copyright year.
     * @param license Your application's license.
     * @param color The color of the AboutWindow.
     *
     * @since 1.0
     */
HeAboutWindow*
he_about_window_construct (GType object_type,
                           GtkWindow* parent,
                           const gchar* app_name,
                           const gchar* app_id,
                           const gchar* version,
                           const gchar* icon,
                           const gchar* translate_url,
                           const gchar* issue_url,
                           const gchar* more_info_url,
                           gchar** translators,
                           gint translators_length1,
                           gchar** developers,
                           gint developers_length1,
                           gint copyright_year,
                           HeAboutWindowLicenses license,
                           HeColors color)
{
	HeAboutWindow * self = NULL;
	gint _tmp0_ = 0;
#line 372 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 372 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 372 "../lib/Widgets/AboutWindow.vala"
	g_return_val_if_fail (app_id != NULL, NULL);
#line 372 "../lib/Widgets/AboutWindow.vala"
	self = (HeAboutWindow*) he_window_construct (object_type);
#line 385 "../lib/Widgets/AboutWindow.vala"
	he_window_set_parent ((HeWindow*) self, parent);
#line 386 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_name (self, app_name);
#line 387 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_app_id (self, app_id);
#line 388 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_version (self, version);
#line 389 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_icon (self, icon);
#line 390 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translate_url (self, translate_url);
#line 391 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_issue_url (self, issue_url);
#line 392 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_more_info_url (self, more_info_url);
#line 393 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_translator_names (self, translators, translators_length1);
#line 394 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_developer_names (self, developers, developers_length1);
#line 395 "../lib/Widgets/AboutWindow.vala"
	if (copyright_year != 0) {
#line 395 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = copyright_year;
#line 1564 "AboutWindow.c"
	} else {
#line 395 "../lib/Widgets/AboutWindow.vala"
		_tmp0_ = 69;
#line 1568 "AboutWindow.c"
	}
#line 395 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_copyright_year (self, _tmp0_);
#line 396 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_license (self, license);
#line 397 "../lib/Widgets/AboutWindow.vala"
	he_about_window_set_color (self, color);
#line 372 "../lib/Widgets/AboutWindow.vala"
	return self;
#line 1578 "AboutWindow.c"
}

HeAboutWindow*
he_about_window_new (GtkWindow* parent,
                     const gchar* app_name,
                     const gchar* app_id,
                     const gchar* version,
                     const gchar* icon,
                     const gchar* translate_url,
                     const gchar* issue_url,
                     const gchar* more_info_url,
                     gchar** translators,
                     gint translators_length1,
                     gchar** developers,
                     gint developers_length1,
                     gint copyright_year,
                     HeAboutWindowLicenses license,
                     HeColors color)
{
#line 372 "../lib/Widgets/AboutWindow.vala"
	return he_about_window_construct (HE_TYPE_ABOUT_WINDOW, parent, app_name, app_id, version, icon, translate_url, issue_url, more_info_url, translators, translators_length1, developers, developers_length1, copyright_year, license, color);
#line 1600 "AboutWindow.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 270 "../lib/Widgets/AboutWindow.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 270 "../lib/Widgets/AboutWindow.vala"
	return _data3_;
#line 1610 "AboutWindow.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 270 "../lib/Widgets/AboutWindow.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1620 "AboutWindow.c"
		HeAboutWindow* self;
#line 270 "../lib/Widgets/AboutWindow.vala"
		self = _data3_->self;
#line 270 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (_data3_->uri_launcher);
#line 270 "../lib/Widgets/AboutWindow.vala"
		_g_object_unref0 (self);
#line 270 "../lib/Widgets/AboutWindow.vala"
		g_slice_free (Block3Data, _data3_);
#line 1630 "AboutWindow.c"
	}
}

static void
_he_about_window___lambda124_ (Block3Data* _data3_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
#line 330 "../lib/Widgets/AboutWindow.vala"
	self = _data3_->self;
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data3_->uri_launcher;
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_translate_url (self);
#line 331 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 331 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 332 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data3_->uri_launcher;
#line 332 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = he_window_get_parent ((HeWindow*) self);
#line 332 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = _tmp4_;
#line 332 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, _tmp5_, NULL, NULL, NULL);
#line 1662 "AboutWindow.c"
}

static void
__he_about_window___lambda124__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 330 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda124_ (self);
#line 1671 "AboutWindow.c"
}

static void
_he_about_window___lambda125_ (Block3Data* _data3_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
#line 335 "../lib/Widgets/AboutWindow.vala"
	self = _data3_->self;
#line 336 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data3_->uri_launcher;
#line 336 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_issue_url (self);
#line 336 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 336 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 337 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data3_->uri_launcher;
#line 337 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = he_window_get_parent ((HeWindow*) self);
#line 337 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = _tmp4_;
#line 337 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, _tmp5_, NULL, NULL, NULL);
#line 1702 "AboutWindow.c"
}

static void
__he_about_window___lambda125__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 335 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda125_ (self);
#line 1711 "AboutWindow.c"
}

static void
_he_about_window___lambda126_ (Block3Data* _data3_)
{
	HeAboutWindow* self;
	GtkUriLauncher* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkUriLauncher* _tmp3_;
	GtkWindow* _tmp4_;
	GtkWindow* _tmp5_;
#line 340 "../lib/Widgets/AboutWindow.vala"
	self = _data3_->self;
#line 341 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = _data3_->uri_launcher;
#line 341 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = he_about_window_get_more_info_url (self);
#line 341 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = _tmp1_;
#line 341 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_set_uri (_tmp0_, _tmp2_);
#line 342 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = _data3_->uri_launcher;
#line 342 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = he_window_get_parent ((HeWindow*) self);
#line 342 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = _tmp4_;
#line 342 "../lib/Widgets/AboutWindow.vala"
	gtk_uri_launcher_launch (_tmp3_, _tmp5_, NULL, NULL, NULL);
#line 1742 "AboutWindow.c"
}

static void
__he_about_window___lambda126__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 340 "../lib/Widgets/AboutWindow.vala"
	_he_about_window___lambda126_ (self);
#line 1751 "AboutWindow.c"
}

static void
_gtk_window_close_gtk_button_clicked (GtkButton* _sender,
                                      gpointer self)
{
#line 345 "../lib/Widgets/AboutWindow.vala"
	gtk_window_close ((GtkWindow*) self);
#line 1760 "AboutWindow.c"
}

static GObject *
he_about_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAboutWindow * self;
	Block3Data* _data3_;
	HeButton* close_button = NULL;
	HeButton* _tmp0_;
	HeButton* _tmp1_;
	HeButton* _tmp2_;
	HeButton* _tmp3_;
	HeButton* _tmp4_;
	HeButton* _tmp5_;
	HeButton* _tmp6_;
	GtkOverlay* _tmp7_;
	HeButton* _tmp8_;
	GtkOverlay* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkBox* _tmp20_;
	GtkImage* _tmp21_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	HeModifierBadge* _tmp28_;
	HeModifierBadge* _tmp29_;
	GtkLabel* _tmp30_;
	GtkBox* _tmp31_;
	GtkLabel* _tmp32_;
	GtkBox* _tmp33_;
	HeModifierBadge* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkBox* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkBox* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkBox* _tmp45_;
	GtkLabel* _tmp46_;
	HeButton* _tmp47_;
	HeButton* _tmp48_;
	HeButton* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkBox* _tmp52_;
	HeButton* _tmp53_;
	GtkBox* _tmp54_;
	HeButton* _tmp55_;
	GtkBox* _tmp56_;
	HeButton* _tmp57_;
	GtkUriLauncher* _tmp58_;
	HeButton* _tmp59_;
	HeButton* _tmp60_;
	HeButton* _tmp61_;
	HeButton* _tmp62_;
	GtkWindowHandle* window_handle = NULL;
	GtkWindowHandle* _tmp63_;
	GtkWindowHandle* _tmp64_;
	GtkOverlay* _tmp65_;
	GtkWindowHandle* _tmp66_;
#line 270 "../lib/Widgets/AboutWindow.vala"
	parent_class = G_OBJECT_CLASS (he_about_window_parent_class);
#line 270 "../lib/Widgets/AboutWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 270 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 270 "../lib/Widgets/AboutWindow.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 270 "../lib/Widgets/AboutWindow.vala"
	_data3_->_ref_count_ = 1;
#line 270 "../lib/Widgets/AboutWindow.vala"
	_data3_->self = g_object_ref (self);
#line 271 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 272 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 274 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = he_button_new ("window-close-symbolic", "");
#line 274 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 274 "../lib/Widgets/AboutWindow.vala"
	close_button = _tmp0_;
#line 275 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = close_button;
#line 275 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_disclosure (_tmp1_, TRUE);
#line 276 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = close_button;
#line 276 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 277 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = close_button;
#line 277 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 278 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = close_button;
#line 278 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, 24);
#line 279 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = close_button;
#line 279 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 24);
#line 280 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = close_button;
#line 280 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("Close"));
#line 282 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = self->priv->window_overlay;
#line 282 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = close_button;
#line 282 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_add_overlay (_tmp7_, (GtkWidget*) _tmp8_);
#line 283 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = self->priv->window_overlay;
#line 283 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = self->priv->about_box;
#line 283 "../lib/Widgets/AboutWindow.vala"
	gtk_overlay_set_child (_tmp9_, (GtkWidget*) _tmp10_);
#line 285 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = self->priv->about_box;
#line 285 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp11_, "dialog-content");
#line 286 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = self->priv->about_box;
#line 286 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = self->priv->content_box;
#line 286 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
#line 287 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = self->priv->about_box;
#line 287 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = self->priv->button_box;
#line 287 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 289 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = self->priv->icon_image;
#line 289 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 290 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = self->priv->icon_image;
#line 290 "../lib/Widgets/AboutWindow.vala"
	gtk_image_set_pixel_size (_tmp17_, 128);
#line 291 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = self->priv->icon_image;
#line 291 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp18_, 24);
#line 292 "../lib/Widgets/AboutWindow.vala"
	_tmp19_ = self->priv->icon_image;
#line 292 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "icon-dropshadow");
#line 294 "../lib/Widgets/AboutWindow.vala"
	_tmp20_ = self->priv->content_box;
#line 294 "../lib/Widgets/AboutWindow.vala"
	_tmp21_ = self->priv->icon_image;
#line 294 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
#line 295 "../lib/Widgets/AboutWindow.vala"
	_tmp22_ = self->priv->content_box;
#line 295 "../lib/Widgets/AboutWindow.vala"
	_tmp23_ = self->priv->info_box;
#line 295 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
#line 297 "../lib/Widgets/AboutWindow.vala"
	_tmp24_ = self->priv->info_box;
#line 297 "../lib/Widgets/AboutWindow.vala"
	_tmp25_ = self->priv->title_box;
#line 297 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
#line 298 "../lib/Widgets/AboutWindow.vala"
	_tmp26_ = self->priv->info_box;
#line 298 "../lib/Widgets/AboutWindow.vala"
	_tmp27_ = self->priv->text_box;
#line 298 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
#line 300 "../lib/Widgets/AboutWindow.vala"
	_tmp28_ = self->priv->version_badge;
#line 300 "../lib/Widgets/AboutWindow.vala"
	he_modifier_badge_set_tinted (_tmp28_, TRUE);
#line 301 "../lib/Widgets/AboutWindow.vala"
	_tmp29_ = self->priv->version_badge;
#line 301 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp29_, 24);
#line 302 "../lib/Widgets/AboutWindow.vala"
	_tmp30_ = self->priv->title_label;
#line 302 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp30_, "display");
#line 303 "../lib/Widgets/AboutWindow.vala"
	_tmp31_ = self->priv->title_box;
#line 303 "../lib/Widgets/AboutWindow.vala"
	_tmp32_ = self->priv->title_label;
#line 303 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 304 "../lib/Widgets/AboutWindow.vala"
	_tmp33_ = self->priv->title_box;
#line 304 "../lib/Widgets/AboutWindow.vala"
	_tmp34_ = self->priv->version_badge;
#line 304 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 306 "../lib/Widgets/AboutWindow.vala"
	_tmp35_ = self->priv->copyright_label;
#line 306 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp35_, (gfloat) 0);
#line 307 "../lib/Widgets/AboutWindow.vala"
	_tmp36_ = self->priv->copyright_label;
#line 307 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp36_, FALSE);
#line 308 "../lib/Widgets/AboutWindow.vala"
	_tmp37_ = self->priv->text_box;
#line 308 "../lib/Widgets/AboutWindow.vala"
	_tmp38_ = self->priv->copyright_label;
#line 308 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 310 "../lib/Widgets/AboutWindow.vala"
	_tmp39_ = self->priv->translators_label;
#line 310 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp39_, (gfloat) 0);
#line 311 "../lib/Widgets/AboutWindow.vala"
	_tmp40_ = self->priv->translators_label;
#line 311 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, FALSE);
#line 312 "../lib/Widgets/AboutWindow.vala"
	_tmp41_ = self->priv->text_box;
#line 312 "../lib/Widgets/AboutWindow.vala"
	_tmp42_ = self->priv->translators_label;
#line 312 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp41_, (GtkWidget*) _tmp42_);
#line 314 "../lib/Widgets/AboutWindow.vala"
	_tmp43_ = self->priv->license_label;
#line 314 "../lib/Widgets/AboutWindow.vala"
	gtk_label_set_xalign (_tmp43_, (gfloat) 0);
#line 315 "../lib/Widgets/AboutWindow.vala"
	_tmp44_ = self->priv->license_label;
#line 315 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp44_, TRUE);
#line 316 "../lib/Widgets/AboutWindow.vala"
	_tmp45_ = self->priv->text_box;
#line 316 "../lib/Widgets/AboutWindow.vala"
	_tmp46_ = self->priv->license_label;
#line 316 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp45_, (GtkWidget*) _tmp46_);
#line 318 "../lib/Widgets/AboutWindow.vala"
	_tmp47_ = self->priv->translate_app_button;
#line 318 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_textual (_tmp47_, TRUE);
#line 319 "../lib/Widgets/AboutWindow.vala"
	_tmp48_ = self->priv->report_button;
#line 319 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_tint (_tmp48_, TRUE);
#line 320 "../lib/Widgets/AboutWindow.vala"
	_tmp49_ = self->priv->more_info_button;
#line 320 "../lib/Widgets/AboutWindow.vala"
	he_button_set_is_fill (_tmp49_, TRUE);
#line 322 "../lib/Widgets/AboutWindow.vala"
	_tmp50_ = self->priv->button_box;
#line 322 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
#line 323 "../lib/Widgets/AboutWindow.vala"
	_tmp51_ = self->priv->button_box;
#line 323 "../lib/Widgets/AboutWindow.vala"
	gtk_box_set_homogeneous (_tmp51_, TRUE);
#line 324 "../lib/Widgets/AboutWindow.vala"
	_tmp52_ = self->priv->button_box;
#line 324 "../lib/Widgets/AboutWindow.vala"
	_tmp53_ = self->priv->translate_app_button;
#line 324 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp52_, (GtkWidget*) _tmp53_);
#line 325 "../lib/Widgets/AboutWindow.vala"
	_tmp54_ = self->priv->button_box;
#line 325 "../lib/Widgets/AboutWindow.vala"
	_tmp55_ = self->priv->report_button;
#line 325 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp54_, (GtkWidget*) _tmp55_);
#line 326 "../lib/Widgets/AboutWindow.vala"
	_tmp56_ = self->priv->button_box;
#line 326 "../lib/Widgets/AboutWindow.vala"
	_tmp57_ = self->priv->more_info_button;
#line 326 "../lib/Widgets/AboutWindow.vala"
	gtk_box_append (_tmp56_, (GtkWidget*) _tmp57_);
#line 328 "../lib/Widgets/AboutWindow.vala"
	_tmp58_ = gtk_uri_launcher_new ("");
#line 328 "../lib/Widgets/AboutWindow.vala"
	_data3_->uri_launcher = _tmp58_;
#line 330 "../lib/Widgets/AboutWindow.vala"
	_tmp59_ = self->priv->translate_app_button;
#line 330 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp59_, "clicked", (GCallback) __he_about_window___lambda124__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 335 "../lib/Widgets/AboutWindow.vala"
	_tmp60_ = self->priv->report_button;
#line 335 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp60_, "clicked", (GCallback) __he_about_window___lambda125__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 340 "../lib/Widgets/AboutWindow.vala"
	_tmp61_ = self->priv->more_info_button;
#line 340 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_data ((GtkButton*) _tmp61_, "clicked", (GCallback) __he_about_window___lambda126__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 345 "../lib/Widgets/AboutWindow.vala"
	_tmp62_ = close_button;
#line 345 "../lib/Widgets/AboutWindow.vala"
	g_signal_connect_object ((GtkButton*) _tmp62_, "clicked", (GCallback) _gtk_window_close_gtk_button_clicked, (GtkWindow*) self, 0);
#line 347 "../lib/Widgets/AboutWindow.vala"
	_tmp63_ = (GtkWindowHandle*) gtk_window_handle_new ();
#line 347 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp63_);
#line 347 "../lib/Widgets/AboutWindow.vala"
	window_handle = _tmp63_;
#line 348 "../lib/Widgets/AboutWindow.vala"
	_tmp64_ = window_handle;
#line 348 "../lib/Widgets/AboutWindow.vala"
	_tmp65_ = self->priv->window_overlay;
#line 348 "../lib/Widgets/AboutWindow.vala"
	gtk_window_handle_set_child (_tmp64_, (GtkWidget*) _tmp65_);
#line 350 "../lib/Widgets/AboutWindow.vala"
	_tmp66_ = window_handle;
#line 350 "../lib/Widgets/AboutWindow.vala"
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp66_);
#line 351 "../lib/Widgets/AboutWindow.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "dialog-content");
#line 270 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (window_handle);
#line 270 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (close_button);
#line 270 "../lib/Widgets/AboutWindow.vala"
	block3_data_unref (_data3_);
#line 270 "../lib/Widgets/AboutWindow.vala"
	_data3_ = NULL;
#line 270 "../lib/Widgets/AboutWindow.vala"
	return obj;
#line 2107 "AboutWindow.c"
}

static void
he_about_window_class_init (HeAboutWindowClass * klass,
                            gpointer klass_data)
{
#line 23 "../lib/Widgets/AboutWindow.vala"
	he_about_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_type_class_adjust_private_offset (klass, &HeAboutWindow_private_offset);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_he_about_window_get_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_he_about_window_set_property;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = he_about_window_constructor;
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = he_about_window_finalize;
#line 2126 "AboutWindow.c"
	/**
	     * The theme color of the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COLOR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2132 "AboutWindow.c"
	/**
	     * The license shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_LICENSE_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY] = g_param_spec_enum ("license", "license", "license", HE_ABOUT_WINDOW_TYPE_LICENSES, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2138 "AboutWindow.c"
	/**
	     * The version shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_VERSION_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2144 "AboutWindow.c"
	/**
	     * The name of the application shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_NAME_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2150 "AboutWindow.c"
	/**
	     *  The icon shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ICON_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2156 "AboutWindow.c"
	/**
	     * The translators shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY] = g_param_spec_boxed ("translator-names", "translator-names", "translator-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2162 "AboutWindow.c"
	/**
	     * The developers shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY] = g_param_spec_boxed ("developer-names", "developer-names", "developer-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2168 "AboutWindow.c"
	/**
	     * The copyright year shown in the AboutWindow.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY] = g_param_spec_int ("copyright-year", "copyright-year", "copyright-year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2174 "AboutWindow.c"
	/**
	     * Your application's reverse-domain name.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_ID_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2180 "AboutWindow.c"
	/**
	     * A URL where contributors can help translate the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY] = g_param_spec_string ("translate-url", "translate-url", "translate-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2186 "AboutWindow.c"
	/**
	     * A URL where users can report a problem with the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY] = g_param_spec_string ("issue-url", "issue-url", "issue-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2192 "AboutWindow.c"
	/**
	     * A URL where users can get more information about the application.
	     */
#line 23 "../lib/Widgets/AboutWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY] = g_param_spec_string ("more-info-url", "more-info-url", "more-info-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2198 "AboutWindow.c"
}

static void
he_about_window_instance_init (HeAboutWindow * self,
                               gpointer klass)
{
	GtkOverlay* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkImage* _tmp11_;
	HeButton* _tmp12_;
	HeButton* _tmp13_;
	HeButton* _tmp14_;
	HeModifierBadge* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gchar* _tmp18_;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self->priv = he_about_window_get_instance_private (self);
#line 24 "../lib/Widgets/AboutWindow.vala"
	_tmp0_ = (GtkOverlay*) gtk_overlay_new ();
#line 24 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 24 "../lib/Widgets/AboutWindow.vala"
	self->priv->window_overlay = _tmp0_;
#line 26 "../lib/Widgets/AboutWindow.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 30);
#line 26 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 26 "../lib/Widgets/AboutWindow.vala"
	self->priv->about_box = _tmp1_;
#line 27 "../lib/Widgets/AboutWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 27 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 27 "../lib/Widgets/AboutWindow.vala"
	self->priv->content_box = _tmp2_;
#line 28 "../lib/Widgets/AboutWindow.vala"
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
#line 28 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 28 "../lib/Widgets/AboutWindow.vala"
	self->priv->button_box = _tmp3_;
#line 29 "../lib/Widgets/AboutWindow.vala"
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 29 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 29 "../lib/Widgets/AboutWindow.vala"
	self->priv->info_box = _tmp4_;
#line 30 "../lib/Widgets/AboutWindow.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
#line 30 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 30 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_box = _tmp5_;
#line 31 "../lib/Widgets/AboutWindow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 31 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 31 "../lib/Widgets/AboutWindow.vala"
	self->priv->text_box = _tmp6_;
#line 33 "../lib/Widgets/AboutWindow.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (NULL);
#line 33 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 33 "../lib/Widgets/AboutWindow.vala"
	self->priv->title_label = _tmp7_;
#line 34 "../lib/Widgets/AboutWindow.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (NULL);
#line 34 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp8_);
#line 34 "../lib/Widgets/AboutWindow.vala"
	self->priv->copyright_label = _tmp8_;
#line 35 "../lib/Widgets/AboutWindow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 35 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 35 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_label = _tmp9_;
#line 36 "../lib/Widgets/AboutWindow.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
#line 36 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp10_);
#line 36 "../lib/Widgets/AboutWindow.vala"
	self->priv->license_label = _tmp10_;
#line 38 "../lib/Widgets/AboutWindow.vala"
	_tmp11_ = (GtkImage*) gtk_image_new ();
#line 38 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp11_);
#line 38 "../lib/Widgets/AboutWindow.vala"
	self->priv->icon_image = _tmp11_;
#line 40 "../lib/Widgets/AboutWindow.vala"
	_tmp12_ = he_button_new (NULL, _ ("Translate App"));
#line 40 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 40 "../lib/Widgets/AboutWindow.vala"
	self->priv->translate_app_button = _tmp12_;
#line 41 "../lib/Widgets/AboutWindow.vala"
	_tmp13_ = he_button_new (NULL, _ ("Report a Problem"));
#line 41 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 41 "../lib/Widgets/AboutWindow.vala"
	self->priv->report_button = _tmp13_;
#line 42 "../lib/Widgets/AboutWindow.vala"
	_tmp14_ = he_button_new (NULL, _ ("More Info…"));
#line 42 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 42 "../lib/Widgets/AboutWindow.vala"
	self->priv->more_info_button = _tmp14_;
#line 44 "../lib/Widgets/AboutWindow.vala"
	_tmp15_ = he_modifier_badge_new ("");
#line 44 "../lib/Widgets/AboutWindow.vala"
	g_object_ref_sink (_tmp15_);
#line 44 "../lib/Widgets/AboutWindow.vala"
	self->priv->version_badge = _tmp15_;
#line 107 "../lib/Widgets/AboutWindow.vala"
	self->priv->_color = HE_COLORS_PURPLE;
#line 126 "../lib/Widgets/AboutWindow.vala"
	self->priv->_license = HE_ABOUT_WINDOW_LICENSES_GPLV3;
#line 162 "../lib/Widgets/AboutWindow.vala"
	_tmp16_ = g_new0 (gchar*, 0 + 1);
#line 162 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = _tmp16_;
#line 162 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators_length1 = 0;
#line 162 "../lib/Widgets/AboutWindow.vala"
	self->priv->_translators_size_ = self->priv->translators_length1;
#line 195 "../lib/Widgets/AboutWindow.vala"
	_tmp17_ = g_new0 (gchar*, 0 + 1);
#line 195 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = _tmp17_;
#line 195 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers_length1 = 0;
#line 195 "../lib/Widgets/AboutWindow.vala"
	self->priv->_developers_size_ = self->priv->developers_length1;
#line 226 "../lib/Widgets/AboutWindow.vala"
	_tmp18_ = g_strdup ("");
#line 226 "../lib/Widgets/AboutWindow.vala"
	self->priv->_app_id = _tmp18_;
#line 2346 "AboutWindow.c"
}

static void
he_about_window_finalize (GObject * obj)
{
	HeAboutWindow * self;
#line 23 "../lib/Widgets/AboutWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 24 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->window_overlay);
#line 26 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->about_box);
#line 27 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->content_box);
#line 28 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->button_box);
#line 29 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->info_box);
#line 30 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_box);
#line 31 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->text_box);
#line 33 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->title_label);
#line 34 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->copyright_label);
#line 35 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translators_label);
#line 36 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->license_label);
#line 38 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->icon_image);
#line 40 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->translate_app_button);
#line 41 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->report_button);
#line 42 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->more_info_button);
#line 44 "../lib/Widgets/AboutWindow.vala"
	_g_object_unref0 (self->priv->version_badge);
#line 162 "../lib/Widgets/AboutWindow.vala"
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
#line 195 "../lib/Widgets/AboutWindow.vala"
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
#line 219 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_translate_url);
#line 220 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_issue_url);
#line 221 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_more_info_url);
#line 226 "../lib/Widgets/AboutWindow.vala"
	_g_free0 (self->priv->_app_id);
#line 23 "../lib/Widgets/AboutWindow.vala"
	G_OBJECT_CLASS (he_about_window_parent_class)->finalize (obj);
#line 2401 "AboutWindow.c"
}

/**
 * An AboutWindow is a window that displays information about the application.
 */
static GType
he_about_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAboutWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_about_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAboutWindow), 0, (GInstanceInitFunc) he_about_window_instance_init, NULL };
	GType he_about_window_type_id;
	he_about_window_type_id = g_type_register_static (HE_TYPE_WINDOW, "HeAboutWindow", &g_define_type_info, 0);
	HeAboutWindow_private_offset = g_type_add_instance_private (he_about_window_type_id, sizeof (HeAboutWindowPrivate));
	return he_about_window_type_id;
}

GType
he_about_window_get_type (void)
{
	static volatile gsize he_about_window_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_type_id__once)) {
		GType he_about_window_type_id;
		he_about_window_type_id = he_about_window_get_type_once ();
		g_once_init_leave (&he_about_window_type_id__once, he_about_window_type_id);
	}
	return he_about_window_type_id__once;
}

static void
_vala_he_about_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_color (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_enum (value, he_about_window_get_license (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_version (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_name (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_icon (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 2471 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_translator_names (self, &length));
#line 2476 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 2482 "AboutWindow.c"
		{
			int length;
#line 23 "../lib/Widgets/AboutWindow.vala"
			g_value_set_boxed (value, he_about_window_get_developer_names (self, &length));
#line 2487 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_int (value, he_about_window_get_copyright_year (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_app_id (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_translate_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_issue_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		g_value_set_string (value, he_about_window_get_more_info_url (self));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2521 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2527 "AboutWindow.c"
	}
}

static void
_vala_he_about_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
#line 23 "../lib/Widgets/AboutWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_color (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_license (self, g_value_get_enum (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_version (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_name (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_icon (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
#line 2573 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_translator_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2580 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
#line 2586 "AboutWindow.c"
		{
			gpointer boxed;
#line 23 "../lib/Widgets/AboutWindow.vala"
			boxed = g_value_get_boxed (value);
#line 23 "../lib/Widgets/AboutWindow.vala"
			he_about_window_set_developer_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2593 "AboutWindow.c"
		}
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_copyright_year (self, g_value_get_int (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_app_id (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_translate_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_issue_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 23 "../lib/Widgets/AboutWindow.vala"
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
#line 23 "../lib/Widgets/AboutWindow.vala"
		he_about_window_set_more_info_url (self, g_value_get_string (value));
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2627 "AboutWindow.c"
		default:
#line 23 "../lib/Widgets/AboutWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/AboutWindow.vala"
		break;
#line 2633 "AboutWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

